program rwcpm;

{Dateitransferprogramm zwischen CP/M-vortex und MS-DOS       }
{fuer IBM-kompatible Rechner ueber Interrupt 13H             }
{CP/M-Disketten:  9 Sektoren, 80 Tracks, zweiseitig          }
{Mit Anpassung fuer den vortex 5.25"                         }
{Matthias Ruether, Ulrich Ruether  Stand: 6.8.86             }
{abgendert fr vortex - Format von GHE, Aachen              }

const OFFSET     = 2;
      SECPERTRK  = 9;
      HEADS      = 2;
      SECPERBLK  = 8;
      RECPERBLK  = 32;
      RECPEREINT = 128;
      MAXDIR     = 128;
      MAXBLK     = 177;
      EXM        = 4;
      BLKPERENT  = 4;          { 4 Blcke pro EXTENT }

type  deintrag  = array [0..31] of byte;
      directory = array [1..MAXDIR] of deintrag;
      rec       = array [0..127] of byte;
      daten     = array [1..128] of rec;
      filename  = string [64];
      regpack   = record
                    ax,bx,cx,dx,bp,si,di,ds,es,flags: integer;
                  end;

var   dirbuf: directory;
      datbuf: daten;
      wahl: char;
      msdrv,physdsk,frdircnt,frblkcnt: integer;
      bufvoll: boolean;
      freidir: set of 1..MAXDIR;
      freiblk: set of 2..MAXBLK;


procedure log(drv:integer);
var dummy: array[0..511] of byte;
    register: regpack;
begin
  with register do
    begin
      ax := $0201;       {1 Sektor}
      cx := $0001;       {Bootsektor}
      dx := $0000 + drv; {Kopf und Drive}
      es := seg(dummy);
      bx := ofs(dummy)
    end;
  intr($13,register);
end;

procedure menu;
begin
  writeln;
  writeln ('Moegliche Kommandos:');
  writeln;
  writeln ('(1) CP/M-Directory anzeigen');
  writeln ('(2) Neue CP/M-Diskette anmelden');
  writeln ('(3) Datei von CP/M nach DOS kopieren');
  writeln ('(4) Datei von DOS nach CP/M kopieren');
  writeln ('(5) CP/M-File loeschen');
  writeln ('(6) Neues physikalisches Laufwerk fuer CP/M-Diskette');
  writeln ('(7) Programm Ende');
  writeln ('(?) Diese Liste zeigen');
end;

procedure init;
begin
  bufvoll := false;
  clrscr;
  writeln ('Dateitransfer zwischen CP/M und MS-/PC-DOS');
  writeln;
  repeat
    write ('Welches phys. Laufwerk enthaelt die CP/M-Diskette? (0-3) ');
    readln (physdsk)
  until physdsk in [0..3];
  menu
end;

procedure rw_block (blk:integer; var buffer; command: integer);
var track, sektor, retry, relsec, head: integer;
    dma,count : integer;
    register: regpack;
begin
  relsec := blk * SECPERBLK + OFFSET * SECPERTRK;
  track := relsec div SECPERTRK ;
  head := track mod HEADS;
  track:= track div HEADS;
  sektor := (relsec mod SECPERTRK) + 1;
  dma:=ofs (buffer);
  for count:=1 to SECPERBLK do begin            { Block lesen }
    retry := 0;
    repeat
      with register do
        begin
          ax := (command shl 8) + 1;     {1 Sektoren      }
          cx := (track shl 8) + sektor;
          dx := (head shl 8) + physdsk ; {Kopf und Drive  }
          es := seg(buffer);             {DMA-Segment     }
          bx := dma;                     {DMA-Offset      }
        end;
      intr($13,register);
      if (register.ax and $FF00) <> 0 then
        begin
          retry := retry + 1;
          if retry > 3 then
            begin
              writeln ('Fehler beim Diskzugriff CP/M-Disk');
              halt
            end
        end
    until register.ax and $FF00 = 0;
    dma:=dma+512;
    with register do begin
      sektor:=sektor+1;
      if sektor > SECPERTRK then begin
        sektor:=1;
        head:=head+1;
        if head = HEADS then begin
          head:=0;
          track:=track+1
          end;
        end;
      end;      { WITH }
   end;         { FOR  }
end;

procedure scanfrei;
var i,j: integer;
begin
  freidir := []; frdircnt := 0;
  freiblk := [0..MAXBLK]; frblkcnt := MAXBLK - 1;
  for i := 1 to MAXDIR do
    if dirbuf[i,0] = $E5
    then
      begin
        freidir := freidir + [i];
        frdircnt := frdircnt + 1
      end
    else
      begin
        j := 16;
        while (j<32) and (dirbuf[i,j]<>0) do
          begin
            freiblk := freiblk - [dirbuf[i,j]];
            frblkcnt := frblkcnt - 1;
            j := j + 1;
          end
      end
end;

procedure lese_directory;

var i : integer;
    register : regpack;

begin
  register.ax:=0;
  register.dx:=0;
  intr ($13,register);
  i:=0;
  repeat
    rw_block (0,dirbuf [i*32+1,0],2);
    i:=i+1;
  until i> (MAXDIR/32)/SECPERBLK;
  bufvoll := true;
  scanfrei
end;

procedure zeige_directory;
var i, j: integer;
begin
  if not bufvoll then lese_directory;
  for i := 1 to MAXDIR do
    if (dirbuf [i,0] <> $E5) and (dirbuf [i,12] < EXM) then
      begin
        for j := 1 to 8 do write (chr(dirbuf [i,j]));
        write (' ');
        for j := 9 to 11 do write (chr(dirbuf [i,j] and $7F));
        write ('    ')
      end;
    writeln;
    writeln ((frblkcnt * RECPERBLK) div 8,' KByte und ',frdircnt,' Dir-Eintraege frei')
end;

function stupcase(name:filename): filename;
var i: integer;
    ausg: filename;
begin
  ausg := '';
  for i:= 1 to length(name) do ausg := ausg + upcase(name[i]);
  stupcase := ausg
end;

function fname (eintrag: integer): filename;
var i: integer;
    name: filename;
begin
  i := 1; name := '';
  repeat
    name := name + chr(dirbuf[eintrag,i]);
    i := i + 1;
  until (i = 9) or (dirbuf[eintrag,i] = $20);
  if dirbuf[eintrag,9] and $7F <> $20 then
    begin
      name := name + '.';
      i := 9;
      repeat
        name := name + chr(dirbuf[eintrag,i] and $7F);
        i := i + 1
      until (i = 12) or ((dirbuf[eintrag,i] and $7F) = $20);
    end;
  fname := name
end;

function erlaubt(var f:filename): boolean;
const ZSATZ : set of char = ['A'..'Z','0'..'9','!','#'..'&','+','-','/'];
var i,j,k: integer;
    valid: boolean;
begin
  if length(f) > 2
    then if f[2] = ':' then delete(f,1,2);
  valid := false;
  k := length(f);
  if k > 0 then if f[1] <> '.' then
    begin
      i := 1;
      while (i<=8) and (i<=k) and (f[i] in ZSATZ) do i := i + 1;
      if i = k + 1 then valid := true
      else if f[i] = '.'
        then
          begin
            j := i + 1;
            while (j <= k) and (j<=i+3) and (f[j] in ZSATZ) do j := j + 1;
            valid :=  (j = k + 1)
          end
    end;
  erlaubt := valid
end;

function finde_eintrag (cfname:filename; extent:integer): integer;
var i: integer;
begin
  i := 1;
  while (i<=MAXDIR) and
        ((dirbuf[i,0]=$E5)
         or (dirbuf[i,12]<(extent and (256-(EXM-1))))
         or (dirbuf [i,12] > ((extent and (256-(EXM-1))) + 3))
         or (fname(i)<>cfname)) do
     i := i + 1;
  finde_eintrag := i;
end;

procedure kopiere_cm;
var cfname, mfname: filename;
    mfile: file;
    i, j,count, extent, reccount: integer;
    blkoff,recs_read : integer;
    error: boolean;
begin
  if not bufvoll then lese_directory;
  write ('Bitte CP/M-Filenamen eingeben: ');
  readln (cfname);
  cfname := stupcase(cfname);
  if finde_eintrag(cfname,0) <= MAXDIR then begin
    repeat
      write ('Bitte DOS-File-Namen eingeben: ');
      readln (mfname);
      assign (mfile,mfname);
      {$I-} rewrite (mfile); {$I+}
      error := ioresult <> 0;
      if error then
        writeln ('DOS-Datei kann nicht geschrieben werden!')
    until not error;
    extent := 0;                   { Start at the beginning }
    repeat
      i := finde_eintrag(cfname,extent); { Nummer des Eintrags }
      reccount := dirbuf [i,15];
      if extent<>dirbuf[i,12] then reccount:=128;
      recs_read:=reccount;
      blkoff:=(extent and (EXM-1)) * BLKPERENT;
      count := 1;
      j := 16;
      while reccount > 0 do begin
        rw_block(dirbuf[i,j+blkoff],datbuf[count,0],2);
        j := j+1;
        count := count + RECPERBLK;
        reccount := reccount - RECPERBLK
        end;
      blockwrite (mfile,datbuf,recs_read);
      extent := extent + 1
    until (dirbuf[i,15] < RECPEREINT) and (extent=1+dirbuf [i,12]);
    close (mfile)
    end
  else writeln ('File nicht im Directory!')
end;

procedure namenseintrag (fname:filename; extent,eintrag:integer);
var i,j: integer;
    fehler: boolean;
begin
  dirbuf[eintrag,0] := 0;
  i := 1;
  while (i <= length(fname)) and (fname[i] <> '.') do
    begin
      dirbuf[eintrag,i] := ord(fname[i]);
      i := i + 1
    end;
  j := i;
  while j <= 8 do
    begin
      dirbuf[eintrag,j] := $20;
      j := j + 1;
    end;
  if fname[i] = '.' then i := i + 1;
  while (j <= 11) and (i <= length(fname)) do
    begin
      dirbuf[eintrag,j] := ord(fname[i]);
      i := i + 1;
      j := j + 1;
    end;
  while j <= 11 do
    begin
      dirbuf[eintrag,j] := $20;
      j := j + 1
    end;
  dirbuf[eintrag,12] := extent;
  for i := 13 to 31 do dirbuf[eintrag,i] := 0
end;

procedure kopiere_mc;
var cfname, mfname: filename;
    mfile: file;
    reccount,extent,recstoread,datzeiger,eintzeiger,dirzeiger,i,j: integer;
begin
  if not bufvoll then lese_directory;
  write ('Bitte DOS-File-Namen eingeben: ');
  readln (mfname);
  assign (mfile,mfname);
  {$I-} reset (mfile); {$I+}
  if ioresult = 0 then
    begin
      repeat
        write ('Bitte CP/M-File-Namen eingeben: ');
        readln (cfname);
        cfname := stupcase(cfname)
      until erlaubt(cfname);
      reccount := FileSize(mfile);
      if ((reccount-1) div RECPERBLK < frblkcnt) and
          (reccount div RECPEREINT < frdircnt) then
        begin
          i := 0;
          while finde_eintrag(cfname,i) <= MAXDIR do
            begin
              j := finde_eintrag(cfname,i);
              dirbuf[j,0] := $E5;
              i := i + 1
            end;
          scanfrei;
          extent := 0;
          dirzeiger := 1; j := 1;
          while reccount >= 0 do
            begin
              while not (dirzeiger in freidir) do dirzeiger := dirzeiger + 1;
              freidir := freidir - [dirzeiger];
              frdircnt := frdircnt - 1;
              eintzeiger:=16;
              namenseintrag(cfname,extent,dirzeiger);
              repeat
                if reccount > RECPEREINT then recstoread := RECPEREINT
                                         else recstoread := reccount;
                dirbuf[dirzeiger,15] := recstoread;
                dirbuf[dirzeiger,12] := extent;
                blockread (mfile,datbuf,recstoread);
                datzeiger:=1;
                while recstoread > 0 do
                  begin
                    while not (j in freiblk) do j := j + 1;
                    rw_block(j,datbuf[datzeiger,0],3);
                    dirbuf[dirzeiger,eintzeiger] := j;
                    freiblk := freiblk - [j];
                    frblkcnt := frblkcnt - 1;
                    j := j + 1;
                    datzeiger := datzeiger + RECPERBLK;
                    eintzeiger := eintzeiger + 1;
                    recstoread := recstoread - RECPERBLK
                  end;
                extent := extent + 1;
                reccount := reccount - RECPEREINT;
              until (extent mod EXM =0) or (reccount <= 0)
            end;
           i:=0;
           repeat
             rw_block (0,dirbuf [i*32+1,0],3);
             i:=i+1;
           until i> (MAXDIR/32)/SECPERBLK;
        end
      else writeln ('Diskette oder Directory voll!')
    end
  else writeln ('DOS-File nicht gefunden!')
end;

procedure loesche;
var cfname: filename;
    i,j: integer;
begin
  write ('Welches CP/M-File soll geloescht werden? '); readln (cfname);
  if length(cfname) > 0 then
    begin
      cfname := stupcase(cfname);
      for i:=0 to MAXDIR do if fname(i)=cfname then dirbuf[i,0]:=$e5;
      i:=0;
      repeat
        rw_block (0,dirbuf [i*32+1,0],3);
        i:=i+1;
      until i> (MAXDIR/32)/SECPERBLK;
      scanfrei
      end
     else writeln ('File nicht im Directory!')
end;

var register : regpack;

begin {rwcpm}
  init;
  writeln;
  repeat
     repeat
        write ('Kommando:');
        read (wahl);
        writeln;
        if not (wahl in ['1'..'7','?']) then writeln ('????')
     until wahl in ['1'..'7','?'];
     case wahl of
       '1': zeige_directory;
       '2': begin
              log (physdsk);
              lese_directory;
              zeige_directory
            end;
       '3': kopiere_cm;
       '4': kopiere_mc;
       '5': loesche;
       '6': init;
       '?': menu
       end
  until wahl = '7'
end.
